package com.idtech.connector;

import jpos.util.tracing.Tracer;

import com.idtech.service.uSignEventListener;

public class uSignConnector {
	/**
	 * open
	 */
	public boolean open(String DeviceClass, String DeviceName, String SDK)
	{
		isBeginCapture = false;
		eventNotify = false;
		listener = null;
		return uSign_Openj(DeviceClass, DeviceName, SDK);
	}
	
	/**
	 * getVersion
	 */
	public String getVersion()
	{
		return uSign_GetVersionj();
	}
	
	/**
	 * close
	 */
	public void close()
	{
		isBeginCapture = false;
		uSign_Closej();
	}
	
	/**
	 * startCapture
	 */
	public boolean startCapture()
	{
		isBeginCapture = true;
		threadStartCapture = new ThreadStartCapture();
		threadStartCapture.start();
		try {
			Thread.sleep(300);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		if(isBeginCapture)
		{
			threadGetCaptureData = new ThreadGetCaptureData();
			threadGetCaptureData.start();
		}
		return isBeginCapture;
	}
	
	/**
	 * exitCapture
	 */
	public boolean exitCapture()
	{
		isBeginCapture = false;
		return exitCapturej();
	}
	
	/**
	 * clearSignature
	 */
	public void clearSignature()
	{
		clearSignaturej();
	}
	
	// EventListener functions
	public void enableEventNotify(boolean enable)
	{
		eventNotify = enable;
	}
		
	public void registeruSignEventListener(uSignEventListener l) {
		enableEventNotify(true);
		listener = l;
	}
		
	public void removeuSignEventListener() {
		enableEventNotify(false);
		listener = null;
	}
		
	class ThreadStartCapture extends Thread
	{
		public void run () {
			byte res = -1;
			res = startCapturej();
			if(res != 0)
			{
				//listener.captureError();
				isBeginCapture = false;
			}
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return;
			}
		}
	}
	class ThreadGetCaptureData extends Thread
	{
		public void run ()
		{
			int[] buf = new int[256];
			int len = 0;
			int[] data;
			while(isBeginCapture)
			{
				len = 0;
				len = getCaptureDataj(buf);
				if (len > 0 && eventNotify && listener != null)
				{
					data = new int[len];					
					for (int i = 0; i < len; i++)
						data[i] = buf[i];
					listener.captureDataEntry(data, len); 
				}
			}
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return;
			}
		}
	}
	
	// Native functions
	private native boolean uSign_Openj(String DeviceClass, String DeviceName, String SDK);
	private native String uSign_GetVersionj();
	private native void uSign_Closej();
	private native byte startCapturej();
	private native byte getCaptureDataj(int[] buf);
	private native boolean exitCapturej();
	private native boolean clearSignaturej();
	
	static{
		//Loger.println("Load JNI connector library..."); 
		Tracer.getInstance().println("Load JNI connector library...");
		System.loadLibrary("com_idtech_connector_uSignConnector");
	}
	
	private boolean eventNotify;
	private boolean isBeginCapture;
	private uSignEventListener listener;
	private ThreadStartCapture threadStartCapture;
	private ThreadGetCaptureData threadGetCaptureData;

}
